package examplemodifie;


import java.awt.FlowLayout;
import java.awt.image.BufferedImage;

import javax.swing.JFrame;

import com.github.sarxos.webcam.Webcam;
import com.github.sarxos.webcam.WebcamImageTransformer;
import com.github.sarxos.webcam.WebcamPanel;
import com.github.sarxos.webcam.WebcamResolution;
import com.github.sarxos.webcam.util.jh.JHGrayFilter;


public class ModifiedImageTransformerExample implements WebcamImageTransformer {

	private static final JHGrayFilter GRAY = new JHGrayFilter();

	@Override
	public BufferedImage transform(BufferedImage image) {
		return GRAY.filter(image, null);
	}

	public ModifiedImageTransformerExample() {
		

		Webcam webcam = Webcam.getDefault();
		webcam.setViewSize(WebcamResolution.QQVGA.getSize());
		webcam.setImageTransformer(this);
		
		try {
			 Webcam.class.newInstance();
		} catch (Exception e) {
			// TODO: handle exception
		}
		
		Webcam webcam1 = Webcam.getDefault();
		webcam1.setViewSize(WebcamResolution.QQVGA.getSize());
		webcam1.setImageTransformer(null);
		
		webcam.open();
		webcam1.open();

		JFrame window = new JFrame("Test Transformer");
		
		window.setLayout(new FlowLayout());
		
		WebcamPanel panel = new WebcamPanel(webcam);
		panel.setFPSDisplayed(true);
		panel.setFillArea(true);
		
		WebcamPanel panel1 = new WebcamPanel(webcam1);
		panel1.setFPSDisplayed(true);
		panel1.setFillArea(true);

		window.add(panel);
		window.add(panel1);
		
		window.pack();
		window.setVisible(true);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public static void main(String[] args) {
		new ModifiedImageTransformerExample();
	}

}
