package software;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.Enumeration;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.JMenu;
import javax.swing.JRadioButtonMenuItem;

import com.github.sarxos.webcam.Webcam;

import software.util.StringName;

@SuppressWarnings("serial")
public class JMenuWebcam extends JMenu {
	// menu de choix de la camera active
	public static JRadioButtonMenuItem[] jradiobttmnItemCameraArray;
	public static ButtonGroup grpradiobttmnItemCamera;
	public static ChooseCameraListener jradiobttmnItemCameraListener = null;
	public static JMenu mnCameraChoose;
	
	// menu de choix de la dimension
	public static JRadioButtonMenuItem[] jradiobttmnItemDimArray;
	public static ButtonGroup grpradiobttmnItemDim;
	public static ChooseDimListener jradiobttmnItemDimListener = null;
	public static JMenu mnDimChoose;
	
	public JMenuWebcam() {
		super();
		
		setText("Camera");
		setMnemonic(KeyEvent.VK_C);
		
		add(mnCameraChoose = new JMenu("Choose Camera") );
		jradiobttmnItemCameraListener = new ChooseCameraListener();
		
		add(mnDimChoose = new JMenu("Choose Dimension") );
		jradiobttmnItemDimListener = new ChooseDimListener();
		
	}

	/** Listens to the radio buttons from {@link mnCameraChoose }. */
	public class ChooseCameraListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
					
			Enumeration<AbstractButton> allRadioButton=grpradiobttmnItemCamera.getElements();  
	        while(allRadioButton.hasMoreElements())  
	        {  
	        	JRadioButtonMenuItem temp=(JRadioButtonMenuItem)allRadioButton.nextElement();  
	           if(temp.isSelected()) { 
	        	   //info : temp.getActionCommand() == Webcam.getName()
	        	   WebcamSync.updtchoosingWebcam(temp.getActionCommand());
	           }  
	        }
	        
	        
		}
	}
	
	/** Listens to the radio buttons from {@link mnDimChoose }. */
	public class ChooseDimListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
					
			Enumeration<AbstractButton> allRadioButton=grpradiobttmnItemDim.getElements();  
	        while(allRadioButton.hasMoreElements())  
	        {  
	        	JRadioButtonMenuItem temp=(JRadioButtonMenuItem)allRadioButton.nextElement();  
	           if(temp.isSelected()) { 
	        	   WebcamSync.updtchoosingWebcamDimension(temp.getActionCommand());
	           }  
	        }
	        
	        
		}
	}

	/** Update the content of {@link JMenuWebcam}.<p>
	 * <ul>Remove, add, and select corresponding item in order to corresponding to parameters...
	 * </ul>
	 * @param arrayWebcam
	 * @param choosingWebcam
	 * @param choosingWebcamDimension 
	 * @param arrayWebcamDimension 
	 */
	public static void update(Webcam[] arrayWebcam, Webcam choosingWebcam, Dimension[] arrayWebcamDimension, Dimension choosingWebcamDimension) {
		
		mnCameraChoose.removeAll();
		mnDimChoose.removeAll();
		
		if (arrayWebcam != null) {
			jradiobttmnItemCameraArray = new JRadioButtonMenuItem[arrayWebcam.length];
			grpradiobttmnItemCamera = new ButtonGroup();
			
			jradiobttmnItemDimArray = new JRadioButtonMenuItem[arrayWebcamDimension.length];
			grpradiobttmnItemDim = new ButtonGroup();
			
			//webcam array
	        for (int i = 0; i < arrayWebcam.length; i++) {
	        	
	        	jradiobttmnItemCameraArray[i] = new JRadioButtonMenuItem(arrayWebcam[i].getName());
	        		        	     	
	        	if (arrayWebcam[i].equals(choosingWebcam)) {
	        		jradiobttmnItemCameraArray[i].setSelected(true);
	        	}
	        	//action & listner
	        	jradiobttmnItemCameraArray[i].setActionCommand(arrayWebcam[i].getName());
	        	jradiobttmnItemCameraArray[i].addActionListener(jradiobttmnItemCameraListener);
	        	//update view
	        	mnCameraChoose.add(jradiobttmnItemCameraArray[i]);
	        	grpradiobttmnItemCamera.add(jradiobttmnItemCameraArray[i]);
	        }
	        
			//webcam dimension
	        for (int i = 0; i < arrayWebcamDimension.length; i++) {
	        	
	        	jradiobttmnItemDimArray[i] = new JRadioButtonMenuItem(software.util.StringName.DimensionToTxt(arrayWebcamDimension[i]));
	        		        	     	
	        	if (arrayWebcamDimension[i].equals(choosingWebcamDimension)) {
	        		jradiobttmnItemDimArray[i].setSelected(true);
	        	}
	        	//action & listner
	        	jradiobttmnItemDimArray[i].setActionCommand(arrayWebcamDimension[i].toString());
	        	jradiobttmnItemDimArray[i].addActionListener(jradiobttmnItemDimListener);
	        	//update view
	        	mnDimChoose.add(jradiobttmnItemDimArray[i]);
	        	grpradiobttmnItemDim.add(jradiobttmnItemDimArray[i]);
	        }
		}
		
	}


}
