package software;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;

import javax.imageio.ImageIO;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;

import software.util.MinSizeBorderLayoutPanel;

import com.github.sarxos.webcam.Webcam;
import com.github.sarxos.webcam.WebcamEvent;
import com.github.sarxos.webcam.WebcamListener;
import com.github.sarxos.webcam.WebcamPanel;
import com.github.sarxos.webcam.WebcamResolution;


@SuppressWarnings("serial")
public class JPanelWebcam extends JPanel {

	
	public static Executor executor = Executors.newSingleThreadExecutor();
	public static boolean stopthread = false;
	
	public static Dimension captureSize;
	public static Dimension displaySize;

	public static  Webcam webcam;
	public static  WebcamPanel panel;
	private JPanelWebcamButton panelbutton;


	public JPanelWebcam() {

		super();
		
//		setPreferredSize(new Dimension(500, 300));
//		setSize(new Dimension(500, 300));
		
		if (WebcamSync.getChoosingWebcam() != null) {
			
			webcam = WebcamSync.getChoosingWebcam();
			
			//setBackground(Color.gray);
			setLayout(new BorderLayout(0, 0));
			
			captureSize = webcam.getViewSizes()[webcam.getViewSizes().length - 1];
			System.out.println("captureSize : "+ captureSize.toString());
			
			if (WebcamSync.getChoosingWebcamDimesion() == null){
				displaySize = webcam.getViewSizes()[0];
			}else{
				displaySize = WebcamSync.getChoosingWebcamDimesion();
			}
			
			System.out.println("displaySize : "+ displaySize.toString());
			
			webcam.setViewSize(displaySize);

			panel = new WebcamPanel(webcam, displaySize, false);
			panel.setBorder(UIManager.getBorder("Button.border"));
			panel.setFPSDisplayed(true);
			panel.setFillArea(false);
			panel.setMinimumSize(displaySize);
			panel.setMaximumSize(displaySize);
			panel.setAutoscrolls(false);
			//panel.setMaximumSize(displaySize);

			// start application with disable snapshot button - we enable it when
			// webcam is started

			panelbutton = new JPanelWebcamButton();
			panelbutton.setMinimumSize(new Dimension(100, panel.getMinimumSize().height));
			
			
			
			add(panel, BorderLayout.WEST);
			add(panelbutton, BorderLayout.EAST);
			
			

			
		} else {
			setLayout(new BorderLayout());
			JLabel lblNowebcam = new JLabel("No webcam connected");
			lblNowebcam.setForeground(Color.RED);
			lblNowebcam.setIcon(new ImageIcon("/com/github/sarxos/webcam/icons/camera-icon.png"));
			add(lblNowebcam,BorderLayout.CENTER);
			
			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : please, connect some camera", JPanelConsole.WARNING);
			System.out.println(this.getClass().getSimpleName()+" : please, connect some camera");
		}
		
		setMinimumSize(new MinSizeBorderLayoutPanel(this));
		setPreferredSize(getMinimumSize());
		setVisible(true);
		

		
	}
	
	/** Method to close properly {@link JPanelWebcam}.<p>
	 *  Usable to close webcam in use. 
	 */
	public void dispose(){
		if (panel != null) {
			panel.stop();
		}
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : dispose()", JPanelConsole.GOOD);
	}
	
//	//boolean paintRequested = false;
//	@Override
//	public void paint(Graphics g) {
//		super.paint(g);
//		System.out.println("g.toString()"+g.toString());
//		//if (g.getClass().getComponentType() == )
//			
////		try {
////			Thread.sleep(1);
////			repaint();
////			System.out.println("repaint");
////		} catch (InterruptedException e) {
////			// TODO Auto-generated catch block
////			e.printStackTrace();
////		}
//	}
	
	
}
