package software;

import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.SpringLayout;
import javax.swing.JButton;


import software.action.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import java.awt.Font;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.Insets;

@SuppressWarnings("serial")
public class JPanelWebcamButton extends JPanel {
	 public static JButton btnStartView;
	 public static JButton btnStartScan;
	 public static JButton btnStopScan;
	 public static JButton btnStopView;
	 public static JButton btnSnap;

	/**
	 * Create the panel.
	 */
	public JPanelWebcamButton() {

		initComponents();
	}
	private void initComponents() {
				
		setBorder(null);
		
		btnStartView = new JButton(new StartViewAction());
		btnStartView.setMargin(new Insets(2, 4, 2, 4));
		btnStartView.setFont(new Font("Dialog", Font.BOLD, 10));
		btnStartView.setVerticalAlignment(SwingConstants.TOP);
		btnStartView.setEnabled(true);
		
		btnStartScan = new JButton(new StartScanAction());
		btnStartScan.setMargin(new Insets(2, 4, 2, 4));
		btnStartScan.setFont(new Font("Dialog", Font.BOLD, 10));
		btnStartScan.setVerticalAlignment(SwingConstants.TOP);
		btnStartScan.setEnabled(false);
		
		btnStopScan = new JButton(new StopScanAction());
		btnStopScan.setMargin(new Insets(2, 4, 2, 4));
		btnStopScan.setFont(new Font("Dialog", Font.BOLD, 10));
		btnStopScan.setVerticalAlignment(SwingConstants.TOP);
		btnStopScan.setEnabled(false);
		
		btnStopView = new JButton(new StopViewAction());
		btnStopView.setMargin(new Insets(2, 4, 2, 4));
		btnStopView.setFont(new Font("Dialog", Font.BOLD, 10));
		btnStopView.setVerticalAlignment(SwingConstants.TOP);
		btnStopView.setEnabled(false);
		
		btnSnap = new JButton(new SnapAction());
		btnSnap.setMargin(new Insets(2, 4, 2, 4));
		btnSnap.setFont(new Font("Dialog", Font.BOLD, 10));
		btnSnap.setVerticalAlignment(SwingConstants.BOTTOM);
		btnSnap.setEnabled(false);
		
		setMinimumSize(new Dimension(100, 170));
		
		GroupLayout groupLayout = new GroupLayout(this);
		groupLayout.setAutoCreateContainerGaps(true);
		groupLayout.setAutoCreateGaps(true);
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING, false)
								.addComponent(btnStartScan, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(btnStartView, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(btnStopScan, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(btnStopView, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
							.addContainerGap(10, Short.MAX_VALUE))
						.addGroup(groupLayout.createSequentialGroup()
							.addComponent(btnSnap, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
							.addGap(10))))
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addGap(5)
					.addComponent(btnStartView)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(btnStartScan)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(btnStopScan)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(btnStopView)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(btnSnap)
					.addGap(10))
		);
		setLayout(groupLayout);
	}
}
