package software;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JSplitPane;

import software.action.AboutAction;
import software.action.ExitAction;
import software.util.MinSizeBorderLayoutPanel;

import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;

import java.awt.Dimension;
import javax.swing.JProgressBar;
import javax.swing.SwingConstants;




@SuppressWarnings("serial")
public class JframePlatine3D extends JFrame  {
	
	public static JPanelConsole jPanelConsole;
	public JPanelWebcam jpanelWebcam;
	public JMenuWebcam mnCamera;
	public JpanelScanning jpanelScanning;
	
	private JMenuBar menuBar;
	private JMenu mnFile;
	private JMenuItem mntmExit;
	private JMenu mnHelp;
	private JMenuItem mntmAbout;
	
	private JPanel panel;
	public static JProgressBar progressBar;
	private JSplitPane splitPane;
	private JPanel panel_1;
	
	public JPanelWebcam getJpanelWebcam() {
		return jpanelWebcam;
	}

	public void setJpanelWebcam() {
		
		if (this.jpanelWebcam != null){
			panel.remove(jpanelWebcam);
			jpanelWebcam.dispose();
		}
		jpanelWebcam = new JPanelWebcam();
		panel.add(jpanelWebcam, BorderLayout.WEST);
				
		MinimumPack();
	}
	
	public void setJpanelScan(int Width , int Height) {
		if (this.jpanelScanning != null){
			panel.remove(jpanelScanning);
			//jpanelScan.dispose();
		}
		
		jpanelScanning = new JpanelScanning(Width,Height);		
		panel.add(jpanelScanning, BorderLayout.CENTER);
				
		MinimumPack();
	}

	

	/**
	 * Create the frame of the application "Platine3D"
	 * 
	 * see {@link AppPlatine3D}.
	 */
	public JframePlatine3D() {
		super();

		build();
		pack();
	}
	
	private void build() {
		setTitle("Platine3D - a simple 3D scanner");
		
		//Close operation via window button
		addWindowListener(new WindowAdapter(){
			    @Override public void windowClosing(    final WindowEvent evt){
			      ExitAction.ExitNow();
			    }
			  }
			);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		//setBounds(100, 100, 650, 300);
		
		menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		mnFile = new JMenu("File");
		mnFile.setMnemonic('F');
		mnFile.setMnemonic(KeyEvent.VK_F);
		menuBar.add(mnFile);
		//Close operation via menu Exit
		mntmExit = new JMenuItem(new ExitAction("Exit"));
		mntmExit.setMnemonic(KeyEvent.VK_E);
		mnFile.add(mntmExit);
		
		mnCamera = new JMenuWebcam();
		menuBar.add(mnCamera);
		
		
		
		mnHelp = new JMenu("Help");
		mnHelp.setMnemonic(KeyEvent.VK_H);
		menuBar.add(mnHelp);
		mntmAbout = new JMenuItem(new AboutAction(this,"About"));
		mntmAbout.setMnemonic(KeyEvent.VK_A);
		mnHelp.add(mntmAbout);
		
		
		setContentPane(buildContentPane());
		setMinimumSize(getContentPane().getMinimumSize());
		
	}
	
	private JSplitPane buildContentPane(){
		
		splitPane = new JSplitPane();
		splitPane.setResizeWeight(0.0);
		splitPane.setBorder(new EmptyBorder(2, 2, 2, 2));
		splitPane.setBackground(Color.gray);//...
		splitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
		
		panel = new JPanel();
		//panel.setPreferredSize(new Dimension(300, 300));
		panel.setBorder(new EmptyBorder(2, 2, 2, 2));
		panel.setLayout(new BorderLayout(0, 0));
		panel.setBackground(Color.white);
		splitPane.add(panel, JSplitPane.LEFT );
		progressBar = new JProgressBar();
		progressBar.setValue(0);
		progressBar.setOrientation(SwingConstants.VERTICAL);
		panel.add(progressBar, BorderLayout.EAST);
		panel_1 = new JPanel();
		panel.add(panel_1, BorderLayout.SOUTH);
		
		
		jPanelConsole = new JPanelConsole();
		jPanelConsole.setPreferredSize(new Dimension(300, 100));
		splitPane.add(jPanelConsole, JSplitPane.RIGHT );
		
		jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : start LOG", JPanelConsole.GOOD);
		
		return splitPane;
		
	}
	
	/** Subroutine for pack (or re-pack) the content of the {@link JframePlatine3D},
	 * spescialy for the content of {@link panel}. This recalculate minimun-size of this Jpanel ( see {@link MinSizeBorderLayoutPanel} ).
	 * 
	 */
	private void MinimumPack(){
		paintAll(this.getGraphics());
		
		panel.setMinimumSize(new MinSizeBorderLayoutPanel(panel));

		splitPane.setMinimumSize(new Dimension( // Math.max(panel.getMinimumSize().width,
												// jPanelConsole.getMinimumSize().width)
				Math.max(panel.getMinimumSize().width,
						jPanelConsole.getMinimumSize().width), panel
						.getMinimumSize().height
						+ jPanelConsole.getMinimumSize().height));

		setMinimumSize(getContentPane().getMinimumSize());

		pack();
	}
	
	
}
