package software;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import javax.swing.JLabel;

import software.Process.ScanImageProcess;
import software.util.MinSizeBorderLayoutPanel;
import javax.swing.JSlider;

@SuppressWarnings("serial")
public class JpanelScanning extends JPanel {

	private int w, h;
	private JLabel lblNewLabel;
	private BufferedImage imageToshow;
	
	/**
	 * Create the panel to view interactively the scanning process
	 *  ({@link StartScanAction} and {@link ScanImageProcess}.
	 * @param Width
	 * @param Height
	 */
	public JpanelScanning(int Width , int Height) {
		w = Width;
		h = Height;
		initComponents();
	}
	
	private void initComponents() {
		
		setLayout(new BorderLayout(0, 0));
		
		lblNewLabel = new JLabel("");
		//lblNewLabel.setIcon(new ImageIcon(imageToshow));
		
		lblNewLabel.setMaximumSize(new Dimension(w, h));
		lblNewLabel.setMinimumSize(new Dimension(w, h));
		add(lblNewLabel,BorderLayout.CENTER);
		
		JSlider slider = new JSlider();
		add(slider, BorderLayout.SOUTH);
		
		setMinimumSize(new MinSizeBorderLayoutPanel(this));
		setPreferredSize(getMinimumSize());
		setVisible(true);
		
		
	}
	
	public void updt(BufferedImage image){
		imageToshow = image;
		this.paint(lblNewLabel.getGraphics());
	}
	
    protected void paintComponent(Graphics g)  
    {  
        super.paintComponent(g);  
        if(imageToshow == null)  
            initImage();  
        g.drawImage(imageToshow, 0, 0, this);  
    } 
    
    private void initImage()  
    {  
        //int w = size.width, h = size.height;  
        
    	// another possibility  
        //Dimension d = tree.getPreferredSize();  
        //int w = d.width, h = d.height;  
        System.out.println("image width = " + w + "\timage height = " + h);  
        imageToshow = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);  
        Graphics2D g2 = imageToshow.createGraphics();  
        g2.setPaint(Color.pink);  
        g2.fillRect(0, 0, w, h); 
        // locate tree inside image  
        //g2.translate(x, y);  
        
        //tree.paint(g2);  
        g2.dispose();  
    }  

}
