package software.Process;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import software.AppPlatine3D;
import software.JframePlatine3D;
import software.action.ExitAction;
import software.util.Math;

public class ScanImageProcess {
	private static int heightMax;
	private static int widthMax;
	
	
	
	/** Return an array of each max red value found in a line and their position in this line
	 * @param img !error if null
	 * @return Integer[][] result formated like this:<P>
	 * 	Integer[img.getHeight()][2]: { /*first line{posittionMax; valueMax } /*second line{posittionMax; valueMax }  ...  /*last line{ posittionMax; valueMax } }
	 */
	/**
	 * @param img
	 * @return
	 */
	public LineArrayRedX[] VerticalRedSearch(BufferedImage img){
		
		assert img != null;
		
		//int result = -1;
		heightMax = img.getHeight(); //System.out.println("height= "+ Ymax);
		widthMax = img.getWidth(); // System.out.println("Width= "+ Xmax);
		
		final int MAX_DIFF_RED = 50;
		
		int y = 0; int x = 0;
		Integer[][] fullLine = new Integer[widthMax][2];
		LineArrayRedX[] res = new LineArrayRedX[heightMax];
		int red;
		//System.out.println("1");
		
		for (y = 0; y < heightMax; y++) { // each lines
			int xMax = 0; int xMaxVal = 0;
			for (x = 0; x < widthMax; x++) { // each colons
				red = ( img.getRGB(x, y) & 0x00ff0000 ) >> 16;
				
				fullLine[x][0]= x;
				fullLine[x][1]= red;
				//result = 1;
//						int clr = image.getRGB(x, y);
//						int red = (clr & 0x00ff0000) >> 16;
//						int green = (clr & 0x0000ff00) >> 8;
//						int blue = clr & 0x000000ff;
				
				if (red > xMaxVal) {
					xMax = x;
					xMaxVal = red;
				}
			}
			
			// detection de la plage
			int xStartPlage = xMax;
			for (x = xMax ; x >= 0 ; x--) {
				if (fullLine[x][1] >= xMaxVal - MAX_DIFF_RED) {
					xStartPlage = x;
				}
			}
			int xEndPlage = xMax;
			for (x = xMax ; x < widthMax ; x++) {
				if (fullLine[x][1] >= xMaxVal - MAX_DIFF_RED) {
					xEndPlage = x;
				}
			}
			
			// moyenne pondérée
			int totalXPondere = 0;
			int totalRed = 0;
			for (x = xStartPlage; x <= xEndPlage; x++) {
				totalXPondere += x * fullLine[x][1];
				totalRed += fullLine[x][1];
			}
			int moyenneX = totalXPondere / totalRed;
			
			res[y] = new LineArrayRedX(y, 0, 0);//TODO utile??
			
			res[y].setColumnpos( moyenneX );//position
			res[y].setRedvalue( fullLine[moyenneX][1] );//value
			
			
			
//			//interpolation de la position
//			float[] interpol;
//			int tmpPos = fullLine[fullLine.length -1][0];
//			int tmpVal = fullLine[fullLine.length -1][1];
//			//System.out.println("3");
//			if (tmpPos != 0 && tmpPos != widthMax -1){
//				int a1 = ( img.getRGB(tmpPos -1, y) & 0x00ff0000 ) >> 16;
//				int a3 = ( img.getRGB(tmpPos +1, y) & 0x00ff0000 ) >> 16;
//				interpol= Math.FloatSubpixelParabolicInterpolation(
//						a1,//value before
//						tmpVal,//value max
//						a3);//value after						
//				res[y].setColumnpos( tmpPos + interpol[0] );//position
//				res[y].setRedvalue( interpol[1] );//value
//				System.out.println("{"+a1+","+tmpVal+","+a3+"}>{"+res[y].getColumnpos()+","+res[y].getRedvalue()+"}");
//			}else{				
//				res[y].setColumnpos( tmpPos );//position
//				res[y].setRedvalue( tmpVal );//value
//				//System.out.println("c= "+res[y].getColumnpos()+" v= "+ res[y].getRedvalue());
//			}			

		}
		
//		//debug	
//		System.out.println("===GlobalArrayRedX===");	
//		for (int i=0 ; i < res.length ; i++){
//			System.out.println(res[i].getLineindex() + " { "+ res[i].getColumnpos() + " : " + res[i].getRedvalue() + " }");	
//		}//debug	
		
		
		return res;
		
	}
	
	/** class for stocking the result of a search maximum value in a line
	 * @author baptiste
	 *
	 */
	public final class LineArrayRedX
	{
	    public void setLineindex(int lineindex) {
			this.lineindex = lineindex;
		}

		public void setColumnpos(float columnpos) {
			this.columnpos = columnpos;
		}

		public void setRedvalue(float redvalue) {
			this.redvalue = redvalue;
		}

		public int getLineindex() {
			return lineindex;
		}

		public float getColumnpos() {
			return columnpos;
		}

		public float getRedvalue() {
			return redvalue;
		}

		private int lineindex;
	    private float columnpos;
	    private float redvalue;
	    


	    /** constructor of {@link LineArrayRedX}.
	     * @param int <b>li </b>
	     * @param float <b>cpos </b>
	     * @param float <b>value </b>
	     */
	    public LineArrayRedX(int li, float cpos, float value)
	    {
	        this.lineindex = li;
	        this.columnpos = cpos;
	        this.redvalue = value;
	    }


	}

	public static BufferedImage BffImgResult(LineArrayRedX[] arrayResult){
		
		BufferedImage r = new BufferedImage(widthMax, heightMax, BufferedImage.TYPE_INT_RGB);  
        Graphics2D g2 = r.createGraphics();  
        g2.setPaint(Color.black);  
        g2.fillRect(0, 0, widthMax, heightMax);
        
        for (int i = 0; i < arrayResult.length; i++){
        	int x;
        	int y;
        	int val;
        	
        	x= (int) arrayResult[i].getColumnpos();
        	y= arrayResult[i].getLineindex();
        	val = (int) arrayResult[i].getRedvalue();
        	
        	try {
        		r.setRGB( x, y, val << 16);
        		
			} catch (Exception e) {
				System.out.println(e.toString());
				System.out.println(" x= "+x+" | y= "+y+" | val= "+val);
				ExitAction.ExitNow();//DEBUB
			}
        	
        	
        }
        
		
		return r;
		
	}
	
}


