package software.Process;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import software.AppPlatine3D;
import software.JframePlatine3D;
import software.action.ExitAction;
import software.util.Math;

public class ScanImageProcess_old {
	private static int Ymax;
	private static int Xmax;
	
	
	
	/** Return an array of each max red value found in a line and their position in this line
	 * @param img !error if null
	 * @return Integer[][] result formated like this:<P>
	 * 	Integer[img.getHeight()][2]: { /*first line{posittionMax; valueMax } /*second line{posittionMax; valueMax }  ...  /*last line{ posittionMax; valueMax } }
	 */
	public LineArrayRedX[] VerticalRedSearch(BufferedImage img){
		
		assert img != null;
		
		//int result = -1;
		Ymax = img.getHeight(); //System.out.println("height= "+ Ymax);
		Xmax = img.getWidth(); // System.out.println("Width= "+ Xmax);
		
		int y = 0; int x = 0;
		//Integer[][] fullLines = new Integer[Xmax][2];
		LineArrayRedX[] res = new LineArrayRedX[Ymax];
		int red;
		//System.out.println("1");
		
		for (y = 0; y < Ymax; y++) { // each lines
			// ADDED GP
			int xMaxRed = Integer.MIN_VALUE;
			int maxRed = Integer.MIN_VALUE;
			for (x = 0; x < Xmax; x++) { // each colons
				red = ( img.getRGB(x, y) & 0x00ff0000 ) >> 16;
				
				//fullLines[x][0]= x;
				//fullLines[x][1]= red;
				//result = 1;
//						int clr = image.getRGB(x, y);
//						int red = (clr & 0x00ff0000) >> 16;
//						int green = (clr & 0x0000ff00) >> 8;
//						int blue = clr & 0x000000ff;
				
				// ADDED GP
				if (maxRed <= red) {
					xMaxRed = x; 
					maxRed = red;
				}
			}
			//System.out.println("2");
			//fullLines = Math.intArraySortAscending(fullLines);
			
			
			res[y] = new LineArrayRedX(y, 0, 0);//TODO utile??
			
			//interpolation de la position
			float[] interpol;
			int tmpPos = xMaxRed; //fullLines[fullLines.length -1][0];
			int tmpVal = maxRed; //fullLines[fullLines.length -1][1];
			//System.out.println("3");
			if (tmpPos != 0 && tmpPos != Xmax -1){
				int a1 = ( img.getRGB(tmpPos -1, y) & 0x00ff0000 ) >> 16;
				int a3 = ( img.getRGB(tmpPos +1, y) & 0x00ff0000 ) >> 16;
				interpol= Math.FloatSubpixelParabolicInterpolation(
						a1,//value before
						tmpVal,//value max
						a3);//value after						
				res[y].setColumnpos( tmpPos + interpol[0] );//position
				res[y].setRedvalue( interpol[1] );//value
				System.out.println("{"+a1+","+tmpVal+","+a3+"}>{"+res[y].getColumnpos()+","+res[y].getRedvalue()+"}");
			}else{				
				res[y].setColumnpos( tmpPos );//position
				res[y].setRedvalue( tmpVal );//value
				//System.out.println("c= "+res[y].getColumnpos()+" v= "+ res[y].getRedvalue());
			}			
//			if (res[y].getColumnpos() == null) {
//				
//			}
		}
		
		//debug	
		System.out.println("===GlobalArrayRedX===");	
		for (int i=0 ; i < res.length ; i++){
			System.out.println(res[i].getLineindex() + " { "+ res[i].getColumnpos() + " : " + res[i].getRedvalue() + " }");	
		}//debug	
		
		
		return res;
		
	}
	
	/** class for stocking the result of a search maximum value in a line
	 * @author baptiste
	 *
	 */
	public final class LineArrayRedX
	{
	    public void setLineindex(int lineindex) {
			this.lineindex = lineindex;
		}

		public void setColumnpos(float columnpos) {
			this.columnpos = columnpos;
		}

		public void setRedvalue(float redvalue) {
			this.redvalue = redvalue;
		}

		public int getLineindex() {
			return lineindex;
		}

		public float getColumnpos() {
			return columnpos;
		}

		public float getRedvalue() {
			return redvalue;
		}

		private int lineindex;
	    private float columnpos;
	    private float redvalue;
	    


	    /** constructor of {@link LineArrayRedX}.
	     * @param int <b>li </b>
	     * @param float <b>cpos </b>
	     * @param float <b>value </b>
	     */
	    public LineArrayRedX(int li, float cpos, float value)
	    {
	        this.lineindex = li;
	        this.columnpos = cpos;
	        this.redvalue = value;
	    }


	}

	public static BufferedImage BffImgResult(LineArrayRedX[] arrayResult){
		
		BufferedImage r = new BufferedImage(Xmax, Ymax, BufferedImage.TYPE_INT_RGB);  
        Graphics2D g2 = r.createGraphics();  
        g2.setPaint(Color.black);  
        g2.fillRect(0, 0, Xmax, Ymax);
        
        for (int i = 0; i < arrayResult.length; i++){
        	int x;
        	int y;
        	int val;
        	
        	x= (int) arrayResult[i].getColumnpos();
        	y= arrayResult[i].getLineindex();
        	val = (int) arrayResult[i].getRedvalue();
        	
        	try {
        		r.setRGB( x, y, val );
			} catch (Exception e) {
				System.out.println(e.toString());
				System.out.println(" x= "+x+" | y= "+y+" | val= "+val);
				ExitAction.ExitNow();//DEBUB
			}
        	
        	
        }
        
		
		return r;
		
	}
	
}


