package software.action;


import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.AbstractAction;

import software.AppPlatine3D;
import software.JPanelConsole;
import software.JPanelWebcam;
import software.JPanelWebcamButton;
import software.JframePlatine3D;

@SuppressWarnings("serial")
public class SnapAction extends AbstractAction implements Runnable {

	public SnapAction() {
		super("Snapshot");
	}

	@Override
	public void actionPerformed(ActionEvent e) {

//		JPanelWebcamButton.btnStartView.setEnabled(true);
//		JPanelWebcamButton.btnStartScan.setEnabled(false);
//		JPanelWebcamButton.btnStopScan.setEnabled(false);
//		JPanelWebcamButton.btnStopView.setEnabled(false);


		// remember to start panel asynchronously - otherwise GUI will be
		// blocked while OS is opening webcam HW (will have to wait for
		// webcam to be ready) and this causes GUI to hang, stop responding
		// and repainting

		JPanelWebcam.executor.execute(this);
		
	}

	@Override
	public void run() {
		try {
			JPanelWebcam.webcam.close();
			JPanelWebcam.webcam.setViewSize(JPanelWebcam.captureSize);
			JPanelWebcam.webcam.open();
			File file = new File(String.format("snapshot-%d.jpg", System.currentTimeMillis()));
			ImageIO.write(JPanelWebcam.webcam.getImage(), "JPG", file);
			//Log
			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : image save in "+ file.getAbsolutePath(), JPanelConsole.GOOD);
			System.out.println("Image saved in " + file.getAbsolutePath());
			
			JPanelWebcam.webcam.close();
			JPanelWebcam.webcam.setViewSize(JPanelWebcam.displaySize);
			JPanelWebcam.webcam.open();
		} catch (IOException e1) {
			e1.printStackTrace();
		}		
	}
}