package software.action;


import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.util.concurrent.atomic.AtomicBoolean;

import javax.swing.AbstractAction;

import com.github.sarxos.webcam.Webcam;



import software.AppPlatine3D;
import software.JPanelConsole;
import software.JPanelWebcam;
import software.JPanelWebcamButton;
import software.JframePlatine3D;
import software.WebcamSync;
import software.Process.ScanImageProcess;
import software.util.Math;

@SuppressWarnings("serial")
public class StartScanAction extends AbstractAction implements Runnable {

	
	
	public StartScanAction() {
		super("Start Scan");
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		JPanelWebcamButton.btnStartView.setEnabled(false);
		JPanelWebcamButton.btnStartScan.setEnabled(false);
		JPanelWebcamButton.btnStopScan.setEnabled(true);
		JPanelWebcamButton.btnStopView.setEnabled(false);

		JPanelWebcamButton.btnSnap.setEnabled(false);
		
		AppPlatine3D.fenetre.setJpanelScan(
				WebcamSync.getChoosingWebcamDimesion().width + 10,
				WebcamSync.getChoosingWebcamDimesion().height + 10);

		// remember to start panel asynchronously - otherwise GUI will be
		// blocked while OS is opening webcam HW (will have to wait for
		// webcam to be ready) and this causes GUI to hang, stop responding
		// and repainting
		JPanelWebcam.stopthread= false;
		JPanelWebcam.executor.execute(this);
	}

	@Override
	public void run() {
		try {
			
			JPanelWebcam.panel.start();
			
			
			do {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				int result = -1;
				BufferedImage image = null;
				if (WebcamSync.getChoosingWebcam().isOpen()) {
					if ((image = WebcamSync.getChoosingWebcam().getImage()) == null) {
						continue;
					}
					result = 1;
					ScanImageProcess RR = new ScanImageProcess();
					ScanImageProcess.LineArrayRedX[] resultArray = RR.VerticalRedSearch(image);

					AppPlatine3D.fenetre.jpanelScanning.updt(ScanImageProcess.BffImgResult(resultArray));
				}
				if (result != -1) {

					
				}
				
//				stopthread.set(true);flagcondition && !Thread.currentThread().isInterrupted()
			} while (!JPanelWebcam.stopthread);

		} catch (Exception e) {
			// TODO erreur pouvant venir d'une utilisation de la webcam déja en
			// cours... Afficher le context exact (voir driver??)
			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass()
					.getSimpleName() + " : " + e, JPanelConsole.WARNING);
			System.out.println("" + e);
		}

	}
}