package software.action;


import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import software.AppPlatine3D;
import software.JPanelConsole;
import software.JPanelWebcam;
import software.JPanelWebcamButton;
import software.JframePlatine3D;

@SuppressWarnings("serial")
public class StartViewAction extends AbstractAction implements Runnable {

	public StartViewAction() {
		super("Start View");
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		JPanelWebcamButton.btnStartView.setEnabled(false);
		JPanelWebcamButton.btnStartScan.setEnabled(true);
		JPanelWebcamButton.btnStopScan.setEnabled(false);
		JPanelWebcamButton.btnStopView.setEnabled(true);
		
		JPanelWebcamButton.btnSnap.setEnabled(true);
		

		// remember to start panel asynchronously - otherwise GUI will be
		// blocked while OS is opening webcam HW (will have to wait for
		// webcam to be ready) and this causes GUI to hang, stop responding
		// and repainting

		JPanelWebcam.executor.execute(this);
	}

	@Override
	public void run() {
		try {
			JPanelWebcam.panel.start();
		} catch (Exception e) {
			//TODO erreur pouvant venir d'une utilisation de la webcam déja en cours... Afficher le context exact (voir driver??)
			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : "+ e, JPanelConsole.WARNING);
			System.out.println(""+e);
		}
		
	}
}