package software.action;


import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import com.github.sarxos.webcam.WebcamListener;

import software.AppPlatine3D;
import software.JPanelConsole;
import software.JPanelWebcam;
import software.JPanelWebcamButton;
import software.JframePlatine3D;

@SuppressWarnings("serial")
public class StopViewAction extends AbstractAction implements Runnable {

	public StopViewAction() {
		super("Stop View");
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		JPanelWebcamButton.btnStartView.setEnabled(true);
		JPanelWebcamButton.btnStartScan.setEnabled(false);
		JPanelWebcamButton.btnStopScan.setEnabled(false);
		JPanelWebcamButton.btnStopView.setEnabled(false);
		
		JPanelWebcamButton.btnSnap.setEnabled(false);

		// remember to start panel asynchronously - otherwise GUI will be
		// blocked while OS is opening webcam HW (will have to wait for
		// webcam to be ready) and this causes GUI to hang, stop responding
		// and repainting

		JPanelWebcam.executor.execute(this);
		
	}

	@Override
	public void run() {
		try {
			JPanelWebcam.webcam.close();
			JPanelWebcam.panel.stop();
			JPanelWebcam.panel.repaint();
		} catch (Exception e) {
			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : "+ e, JPanelConsole.WARNING);
			System.out.println(""+e);
		}
		
	}
}