package examplemodifie;

import javax.swing.JFrame;
import javax.swing.JPanel;

import software.JPanelConsole;
import software.JframePlatine3D;

import java.awt.BorderLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.lang.Thread.UncaughtExceptionHandler;

import com.github.sarxos.webcam.Webcam;
import com.github.sarxos.webcam.WebcamEvent;
import com.github.sarxos.webcam.WebcamListener;
import com.github.sarxos.webcam.WebcamPanel;
import com.github.sarxos.webcam.WebcamResolution;


/** Panel for view Webcam<p>
 *  Based from example class <code><b>WebcamViewerExample</b></code> in <i>webcam-capture-0.3.10-RC4-dist.zip /examples/</i>
 * @author baptiste
 *
 */
public class JpanelWebcamFIRST_TRY extends JPanel implements Runnable, WebcamListener, WindowListener, UncaughtExceptionHandler {

	//private static final long serialVersionUID = 1L;
	private WebcamPanel panel = null;
	static Webcam webcamAssigned = null;
	

	public void setWebcamAssigned(Webcam newWebcam) {
		
		if (newWebcam != null && webcamAssigned != newWebcam ){
			
			final WebcamPanel tmp = panel;
			remove(panel);
			webcamAssigned.removeWebcamListener(this);
	
			webcamAssigned = newWebcam;

			webcamAssigned.setViewSize(WebcamResolution.QQVGA.getSize());
			webcamAssigned.addWebcamListener(this);

			JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : selected " + webcamAssigned.getName(), null);
			System.out.println("selected " + webcamAssigned.getName());

			final WebcamPanel panel = new WebcamPanel(webcamAssigned);

			add(panel, BorderLayout.CENTER);

			Thread t = new Thread() {

				@Override
				public void run() {					
					tmp.stop();					
					panel.start();
				}
			};
			t.setName("example-stoper");
			t.setDaemon(true);
			t.setUncaughtExceptionHandler(this);
			t.start();
		
		}
	}

	
	
	/** Create the panel with the webcam viewer.
	 * 
	 * @param argwebcam
	 */
	public JpanelWebcamFIRST_TRY(Webcam argwebcam) {
		webcamAssigned = argwebcam;
		
	}

	@Override
	public void uncaughtException(Thread t, Throwable e) {
		System.err.println(String.format("Exception in thread %s", t.getName()));
		e.printStackTrace();
	}

	@Override
	public void windowOpened(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent e) {
		webcamAssigned.close();
		
	}

	@Override
	public void windowClosed(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent e) {
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : webcam viewer paused", JPanelConsole.red);
		System.out.println("webcam viewer paused");
		panel.pause();
	}

	@Override
	public void windowDeiconified(WindowEvent e) {
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : webcam viewer resumed", null);
		System.out.println("webcam viewer resumed");
		panel.resume();
	}

	@Override
	public void windowActivated(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void webcamClosed(WebcamEvent arg0) {
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : webcam closed", JPanelConsole.red);
		System.out.println("webcam closed");
		
	}

	@Override
	public void webcamDisposed(WebcamEvent arg0) {
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : webcam disposed", null);
		System.out.println("webcam disposed");
		
	}

	@Override
	public void webcamImageObtained(WebcamEvent arg0) {
		// do nothing
		
	}

	@Override
	public void webcamOpen(WebcamEvent arg0) {
		JframePlatine3D.jPanelConsole.printConsoleLogLine(this.getClass().getSimpleName() + " : webcam open", JPanelConsole.blue);
		System.out.println("webcam open");
		
		
	}

	@Override
	public void run() {
		setLayout(new BorderLayout());

		if (webcamAssigned == null) {
			System.out.println(this.getClass().getSimpleName() + " : No webcams found...");
			System.exit(1);// TODO sorti a supp
		}

		webcamAssigned.setViewSize(WebcamResolution.QQVGA.getSize());
		webcamAssigned.addWebcamListener(JpanelWebcamFIRST_TRY.this);

		panel = new WebcamPanel(webcamAssigned, false);
		panel.setFPSDisplayed(true);

		add(panel, BorderLayout.CENTER);

		setVisible(true);

		Thread panelthread = new Thread() {

			@Override
			public void run() {
				panel.start();
			}
		};
		panelthread.setName("example-starter");
		panelthread.setDaemon(true);
		panelthread.setUncaughtExceptionHandler(this);
		panelthread.start();
		
	}

}
